/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*
 *  ƥॵӥΥåȰ¸STM32P207ѡ
 *
 *  ƥॵӥΥåȰ¸Υ󥯥롼ɥե롥Υե
 *  Ƥϡݡͥȵҥե˵Ҥ졤Υե
 *  ̵ʤ븫ߡ
 */
#ifndef TOPPERS_TARGET_SYSSVC_H
#define TOPPERS_TARGET_SYSSVC_H

#include "stm32p207.h"

/*
 *  ưåΥåȥƥ̾
 */
#define TARGET_NAME    "STM32P207(STM32F207ZET6)"

/*
 *  ƥ٥ϤΤʸ
 *
 *  åȰ¸ˡǡʸcɽ//¸롥
 */
extern void	target_fput_log(char c);

/*
 *  ꥢݡȿ
 */
#define TNUM_PORT        (2)		/* ݡȤ륷ꥢݡȤο */
#define TNUM_SIOP        (2)

/*
 *  ѤݡID
 */
#define LOGTASK_PORTID   SIO_PORTID

/*  
 *  ܡ졼
 */
#define BPS_SETTING		(115200)

/*
 *  ƥϢ
 *
 *  ǥե̤ͤꡥ
 */

/*
 *  å׶ͭΥϡɥ񸻤ɤ߹
 */
#include "arm_m_gcc/stm32f/chip_syssvc.h"

#endif /* TOPPERS_TARGET_SYSSVC_H */
